
(*
  Lazarus 1.4, BGRABitmap 8.5, fpGUI 1.4
  
  Démonstration de l'utilisation de la police True Type Chess Alfonso-X :
  http://www.enpassant.dk/chess/fonteng.htm

  Nécessite la version corrigée de l'unité EasyLazFreetype :
  http://www.developpez.net/forums/d1180437-11/autres-langages/pascal/contribuez/projet-d-programme-jeu-d-echecs/#post8246463
  
  Programme testé sous Windows 8.1.
*)

program chessfont4fpgui;

{$MODE objfpc}{$H+}

uses
  Classes, SysUtils,
  fpg_base, fpg_main, fpg_form,
  BGRABitmapTypes, BGRABitmap;

type

  { TMainForm }

  TMainForm = class(TfpgForm)
    procedure FormPaint(Sender: TObject);
  protected
    FBmp: TBGRABitmap;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AfterCreate; override;
  end;

procedure DrawChessBoard(bmp: TBGRABitmap);
const
  CHARS: array[0..9]of string = (
    '!""""""""#',
    '$tMvWlVmT%',
    '$OoOoOoOo%',
    '$ + + + +%',
    '$+ +wL + %',
    '$ + Qk+ +%',
    '$+ + + + %',
    '$pPpPpPpP%',
    '$RnBqKbNr%',
    '/(((((((()'
  );
var
  i: integer;
begin
  bmp.Fill(BGRAWhite);
  bmp.FontName := 'Chess Alfonso-X';
  bmp.FontHeight := 40;
  for i := 0 to 9 do
    bmp.TextOut(0, 40 * i, CHARS[i], BGRABlack);
end;

{ TMainForm }

procedure TMainForm.FormPaint(Sender: TObject);
begin
  FBmp.SetSize(Width, Height);
  DrawChessBoard(FBmp);
  FBmp.Draw(Canvas, 0, 0);
end;

constructor TMainForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBmp := TBGRABitmap.Create;
end;

destructor TMainForm.Destroy;
begin
  FBmp.Free;
  inherited Destroy;
end;

procedure TMainForm.AfterCreate;
begin
  {%region 'Auto-generated GUI code' -fold}
  {@VFD_BODY_BEGIN: MainForm}
  Name := 'MainForm';
  SetPosition(50, 50, 400, 400);
  WindowTitle := 'BGRABitmap and fpGUI';
  Hint := '';
  WindowPosition := wpOneThirdDown;
  OnPaint := @FormPaint;
  {@VFD_BODY_END: MainForm}
  {%endregion}
end;

procedure MainProc;
var
  frm: TMainForm;
begin
  fpgApplication.Initialize;
  TBGRABitmap.AddFreeTypeFontFolder(GetCurrentDir);
  frm := TMainForm.Create(nil);
  frm.Show;
  fpgApplication.Run;
  frm.Free;
end;

{$R *.res}

begin
  MainProc;
end.

